-- create a scrollable list of known stories
storySelect=Turbine.UI.Lotro.Window()
storySelect:SetSize(800,400)
storySelect:SetPosition((displayWidth-storySelect:GetWidth())/2,(displayHeight-storySelect:GetHeight())/2)
storySelect:SetText(Resource[language][17])

storySelect.CurrLanguageCaption=Turbine.UI.Label()
storySelect.CurrLanguageCaption:SetParent(storySelect)
storySelect.CurrLanguageCaption:SetSize(140,20)
storySelect.CurrLanguageCaption:SetPosition(10,45)
storySelect.CurrLanguageCaption:SetText(Resource[language][232]..":")

storySelect.CurrLanguage=DropDownList()
storySelect.CurrLanguage:SetParent(storySelect)
storySelect.CurrLanguage:SetSize(140,20)
storySelect.CurrLanguage:SetPosition(150,45)
storySelect.CurrLanguage:SetZOrder(2)
storySelect.CurrLanguage:AddItem(Resource[language][209],1)
storySelect.CurrLanguage:AddItem(Resource[language][210],2)
storySelect.CurrLanguage:AddItem(Resource[language][211],3)

storySelect.CurrLanguage:SetSelectedIndex(Settings.CurrentLanguage)
storySelect.CurrLanguage.SelectedIndexChanged=function()
	-- easiest to just refill the list
	local item=storySelect.StoryListBox:GetSelectedItem()
	local id
	if item~=nil then id=item.ID end
	if storySelect.Desc:IsVisible() then
		if id~=nil then
			storySelect.ShowDesc(id)
		end
	end
	storySelect.FillStoryList(storySelect.StoryListBox.SortColumn,id)
end

storySelect.StoryList=Turbine.UI.Control()
storySelect.StoryList:SetParent(storySelect)
storySelect.StoryList:SetSize(storySelect:GetWidth()-20,storySelect:GetHeight()-115)
storySelect.StoryList:SetPosition(10,70)
storySelect.StoryList:SetBackColor(Settings.TrimColor)

storySelect.ActiveHeader=Turbine.UI.Lotro.CheckBox()
storySelect.ActiveHeader:SetParent(storySelect.StoryList)
storySelect.ActiveHeader:SetSize(90,20)
storySelect.ActiveHeader:SetPosition(1,1)
storySelect.ActiveHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
storySelect.ActiveHeader:SetForeColor(Turbine.UI.Color.LightBlue)
storySelect.ActiveHeader:SetMultiline(false)
storySelect.ActiveHeader:SetFont(Settings.Font)
storySelect.ActiveHeader:SetText(Resource[language][29])
storySelect.ActiveHeader.MouseClick=function()
	storySelect.ActiveHeader:SetBackColor(Turbine.UI.Color.Blue)
	storySelect.ActiveHeader:SetForeColor(Turbine.UI.Color.White)
	storySelect.ENHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ENHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.FRHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.FRHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.DEHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.DEHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.AuthorHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.AuthorHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.NameHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.NameHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	local item=storySelect.StoryListBox:GetSelectedItem()
	local id
	if item~=nil then id=item.ID end
	storySelect.FillStoryList(1,id)
end
storySelect.ActiveHeader.CheckedChanged=function()
	storySelect.ApplyFilter()
end
storySelect.ENHeader=Turbine.UI.Lotro.CheckBox()
storySelect.ENHeader:SetParent(storySelect.StoryList)
storySelect.ENHeader:SetSize(75,20)
storySelect.ENHeader:SetPosition(storySelect.ActiveHeader:GetLeft()+storySelect.ActiveHeader:GetWidth(),1)
storySelect.ENHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
storySelect.ENHeader:SetForeColor(Turbine.UI.Color.LightBlue)
storySelect.ENHeader:SetMultiline(false)
storySelect.ENHeader:SetFont(Settings.Font)
storySelect.ENHeader:SetText(Resource[language][209])
storySelect.ENHeader.MouseClick=function()
	storySelect.ActiveHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ActiveHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.ENHeader:SetBackColor(Turbine.UI.Color.Blue)
	storySelect.ENHeader:SetForeColor(Turbine.UI.Color.White)
	storySelect.FRHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.FRHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.DEHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.DEHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.AuthorHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.AuthorHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.NameHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.NameHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	local item=storySelect.StoryListBox:GetSelectedItem()
	local id
	if item~=nil then id=item.ID end
	storySelect.FillStoryList(2,id)
end
storySelect.ENHeader.CheckedChanged=function()
	storySelect.ApplyFilter()
end

storySelect.FRHeader=Turbine.UI.Lotro.CheckBox()
storySelect.FRHeader:SetParent(storySelect.StoryList)
storySelect.FRHeader:SetSize(75,20)
storySelect.FRHeader:SetPosition(storySelect.ENHeader:GetLeft()+storySelect.ENHeader:GetWidth(),1)
storySelect.FRHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
storySelect.FRHeader:SetForeColor(Turbine.UI.Color.LightBlue)
storySelect.FRHeader:SetMultiline(false)
storySelect.FRHeader:SetFont(Settings.Font)
storySelect.FRHeader:SetText(Resource[language][210])
storySelect.FRHeader.MouseClick=function()
	storySelect.ActiveHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ActiveHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.ENHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ENHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.FRHeader:SetBackColor(Turbine.UI.Color.Blue)
	storySelect.FRHeader:SetForeColor(Turbine.UI.Color.White)
	storySelect.DEHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.DEHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.AuthorHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.AuthorHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.NameHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.NameHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	local item=storySelect.StoryListBox:GetSelectedItem()
	local id
	if item~=nil then id=item.ID end
	storySelect.FillStoryList(3,id)
end
storySelect.FRHeader.CheckedChanged=function()
	storySelect.ApplyFilter()
end

storySelect.DEHeader=Turbine.UI.Lotro.CheckBox()
storySelect.DEHeader:SetParent(storySelect.StoryList)
storySelect.DEHeader:SetSize(75,20)
storySelect.DEHeader:SetPosition(storySelect.FRHeader:GetLeft()+storySelect.FRHeader:GetWidth(),1)
storySelect.DEHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
storySelect.DEHeader:SetForeColor(Turbine.UI.Color.LightBlue)
storySelect.DEHeader:SetMultiline(false)
storySelect.DEHeader:SetFont(Settings.Font)
storySelect.DEHeader:SetText(Resource[language][211])
storySelect.DEHeader.MouseClick=function()
	storySelect.ActiveHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ActiveHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.ENHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ENHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.FRHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.FRHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.DEHeader:SetBackColor(Turbine.UI.Color.Blue)
	storySelect.DEHeader:SetForeColor(Turbine.UI.Color.White)
	storySelect.AuthorHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.AuthorHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.NameHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.NameHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	local item=storySelect.StoryListBox:GetSelectedItem()
	local id
	if item~=nil then id=item.ID end
	storySelect.FillStoryList(4,id)
end
storySelect.DEHeader.CheckedChanged=function()
	storySelect.ApplyFilter()
end
storySelect.ApplyFilter=function()
	local activeHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local checkActive=storySelect.ActiveHeader:IsChecked()
	local checkEN=storySelect.ENHeader:IsChecked()
	local checkFR=storySelect.FRHeader:IsChecked()
	local checkDE=storySelect.DEHeader:IsChecked()

	for i=1,storySelect.StoryListBox:GetItemCount() do
		local item=storySelect.StoryListBox:GetItem(i)
		if (checkActive and item.Active:GetText()=="") or (checkEN and item.EN:GetText()=="")or (checkFR and item.FR:GetText()=="")or (checkDE and item.DE:GetText()=="") then
			item:SetHeight(0)
		else
			item:SetHeight(activeHeight)
		end
	end
end

storySelect.AuthorHeader=Turbine.UI.Label()
storySelect.AuthorHeader:SetParent(storySelect.StoryList)
storySelect.AuthorHeader:SetSize(120,20)
storySelect.AuthorHeader:SetPosition(storySelect.DEHeader:GetLeft()+storySelect.DEHeader:GetWidth(),1)
storySelect.AuthorHeader:SetBackColor(Turbine.UI.Color.Blue)
storySelect.AuthorHeader:SetForeColor(Turbine.UI.Color.White)
storySelect.AuthorHeader:SetMultiline(false)
storySelect.AuthorHeader:SetFont(Settings.Font)
storySelect.AuthorHeader:SetText(Resource[language][12])
storySelect.AuthorHeader.MouseClick=function()
	storySelect.ActiveHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ActiveHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.ENHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ENHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.FRHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.FRHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.DEHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.DEHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.AuthorHeader:SetBackColor(Turbine.UI.Color.Blue)
	storySelect.AuthorHeader:SetForeColor(Turbine.UI.Color.White)
	storySelect.NameHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.NameHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	local item=storySelect.StoryListBox:GetSelectedItem()
	local id
	if item~=nil then id=item.ID end
	storySelect.FillStoryList(5,id)
end

storySelect.NameHeader=Turbine.UI.Label()
storySelect.NameHeader:SetParent(storySelect.StoryList)
storySelect.NameHeader:SetSize(200,20)
storySelect.NameHeader:SetPosition(storySelect.AuthorHeader:GetLeft()+storySelect.AuthorHeader:GetWidth(),1)
storySelect.NameHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
storySelect.NameHeader:SetForeColor(Turbine.UI.Color.LightBlue)
storySelect.NameHeader:SetMultiline(false)
storySelect.NameHeader:SetFont(Settings.Font)
storySelect.NameHeader:SetText(Resource[language][13])
storySelect.NameHeader.MouseClick=function()
	storySelect.ActiveHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ActiveHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.ENHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.ENHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.FRHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.FRHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.DEHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.DEHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.AuthorHeader:SetBackColor(Turbine.UI.Color.DarkBlue)
	storySelect.AuthorHeader:SetForeColor(Turbine.UI.Color.LightBlue)
	storySelect.NameHeader:SetBackColor(Turbine.UI.Color.Blue)
	storySelect.NameHeader:SetForeColor(Turbine.UI.Color.White)
	local item=storySelect.StoryListBox:GetSelectedItem()
	local id
	if item~=nil then id=item.ID end
	storySelect.FillStoryList(6,id)
end

storySelect.StoryListBox=Turbine.UI.ListBox()
storySelect.StoryListBox:SetParent(storySelect.StoryList)
storySelect.StoryListBox:SetSize(storySelect.StoryList:GetWidth()-12,storySelect.StoryList:GetHeight()-22)
storySelect.StoryListBox:SetBackColor(Turbine.UI.Color.Black)
storySelect.StoryListBox:SetPosition(1,21)
storySelect.StoryListBox.LastSelected=nil

storySelect.StoryListBox.SelectedIndexChanged=function(sender,args)
	local tmpItem
	if storySelect.StoryListBox.LastSelected~=nil and storySelect.StoryListBox.LastSelected>0 then
		tmpItem=storySelect.StoryListBox:GetItem(storySelect.StoryListBox.LastSelected)
		if tmpItem~=nil then
			if tmpItem.Supported then
				tmpItem:SetBackColor(nil)
			else
				tmpItem:SetBackColor(Turbine.UI.Color.DarkRed)
			end
		end
	end
	storySelect.StoryListBox.LastSelected=storySelect.StoryListBox:GetSelectedIndex()
	if storySelect.StoryListBox.LastSelected~=nil and storySelect.StoryListBox.LastSelected>0 then
		tmpItem=storySelect.StoryListBox:GetItem(storySelect.StoryListBox.LastSelected)
		if tmpItem~=nil then
			if tmpItem.Supported then
				tmpItem:SetBackColor(Turbine.UI.Color(0,.1,.2))
			else
				tmpItem:SetBackColor(Turbine.UI.Color.Red)
			end
		end
	end
end

storySelect.StoryListVScroll=Turbine.UI.Lotro.ScrollBar()
storySelect.StoryListVScroll:SetParent(storySelect.StoryList)
storySelect.StoryListVScroll:SetSize(10,storySelect.StoryListBox:GetHeight())
storySelect.StoryListVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
storySelect.StoryListVScroll:SetPosition(storySelect.StoryListBox:GetLeft()+storySelect.StoryListBox:GetWidth(),storySelect.StoryListBox:GetTop())
storySelect.StoryListBox:SetVerticalScrollBar(storySelect.StoryListVScroll)

storySelect.Desc=Turbine.UI.Control()
storySelect.Desc:SetParent(storySelect)
storySelect.Desc:SetBackColor(Settings.TrimColor)
storySelect.Desc:SetZOrder(1)
storySelect.Desc:SetSize(storySelect:GetWidth()-100,storySelect:GetHeight()-200)
storySelect.Desc:SetPosition(50,100)
storySelect.Desc:SetVisible(false)
storySelect.DescText=Turbine.UI.Label()
storySelect.DescText:SetParent(storySelect.Desc)
storySelect.DescText:SetSize(storySelect.Desc:GetWidth()-2,storySelect.Desc:GetHeight()-2)
storySelect.DescText:SetSelectable(true)
storySelect.DescText:SetPosition(1,1)
--storySelect.DescText:SetMouseVisible(false)
storySelect.DescText:SetBackColor(Settings.BackColor)

storySelect.DescText.MouseClick=function(sender,args)
	if args.Button==2 then
		storySelect.Desc:SetVisible(false)
	end
end
--storySelect.DescText.MouseLeave=function()
--	storySelect.Desc:SetVisible(false)
--end
storySelect.ShowDesc=function(ID)
	local tmpLanguage=storySelect.CurrLanguage:GetValue()
	local msg=Resource[tmpLanguage][231].."\n"
	if tmpLanguage==2 and StoryList[ID].DescFR~=nil then
		msg=msg..StoryList[ID].DescFR
	elseif tmpLanguage==3 and StoryList[ID].DescDE~=nil then
		msg=msg..StoryList[ID].DescDE
	elseif StoryList[ID].Desc~=nil then
		msg=msg..StoryList[ID].Desc
	end
	storySelect.DescText:SetText(msg)
	storySelect.Desc:SetVisible(true)
end

storySelect.FillStoryList=function(sortColumn,SelectedID)
	storySelect.StoryListBox:ClearItems()
	storySelect.StoryListBox.LastSelected=nil
	storySelect.StoryListBox.SortColumn=sortColumn
	tmpStoryList={} -- create a temporary list that we can sort without losing the original ID
	for k,v in ipairs(StoryList) do
		local active=""
		if (v.ActiveChapter~=nil) then active="Y" end
		local en=""
		if (v.EN~=nil and v.EN==true) then en="Y" end
		local fr=""
		if (v.FR~=nil and v.FR==true) then fr="Y" end
		local de=""
		if (v.DE~=nil and v.DE==true) then de="Y" end
		if storySelect.CurrLanguage:GetValue()==2 then
			table.insert(tmpStoryList,{["IsActive"]=active,["ID"]=v.ID,["Author"]=v.Author,["Name"]=v.NameFR,["Desc"]=v.DescFR,["EN"]=en,["FR"]=fr,["DE"]=de})
		elseif storySelect.CurrLanguage:GetValue()==3 then
			table.insert(tmpStoryList,{["IsActive"]=active,["ID"]=v.ID,["Author"]=v.Author,["Name"]=v.NameDE,["Desc"]=v.DescDE,["EN"]=en,["FR"]=fr,["DE"]=de})
		else
			table.insert(tmpStoryList,{["IsActive"]=active,["ID"]=v.ID,["Author"]=v.Author,["Name"]=v.Name,["Desc"]=v.Desc,["EN"]=en,["FR"]=fr,["DE"]=de})
		end
	end
	if sortColumn==nil then sortColumn=1 end
	if sortColumn==1 then
		--active
		table.sort(tmpStoryList,function(arg1,arg2) if arg1.IsActive>arg2.IsActive then return true else if arg1.IsActive==arg2.IsActive and arg1.Author<arg2.Author then return true else if arg1.IsActive==arg2.IsActive and arg1.Author==arg2.Author and arg1.Name<arg2.Name then return true end end end end)
	elseif sortColumn==2 then
		--en
		table.sort(tmpStoryList,function(arg1,arg2) if arg1.EN>arg2.EN then return true else if arg1.EN==arg2.EN and arg1.Author<arg2.Author then return true else if arg1.EN==arg2.EN and arg1.Author==arg2.Author and arg1.Name<arg2.Name then return true end end end end)
	elseif sortColumn==3 then
		--fr
		table.sort(tmpStoryList,function(arg1,arg2) if arg1.FR>arg2.FR then return true else if arg1.FR==arg2.FR and arg1.Author<arg2.Author then return true else if arg1.FR==arg2.FR and arg1.Author==arg2.Author and arg1.Name<arg2.Name then return true end end end end)
	elseif sortColumn==4 then
		--de
		table.sort(tmpStoryList,function(arg1,arg2) if arg1.DE>arg2.DE then return true else if arg1.DE==arg2.DE and arg1.Author<arg2.Author then return true else if arg1.DE==arg2.DE and arg1.Author==arg2.Author and arg1.Name<arg2.Name then return true end end end end)
	elseif sortColumn==5 then
		table.sort(tmpStoryList,function(arg1,arg2) if arg1.Author<arg2.Author then return true else if arg1.Author==arg2.Author and arg1.Name<arg2.Name then return true end end end)
	elseif sortColumn==6 then
		table.sort(tmpStoryList,function(arg1,arg2) if arg1.Name<arg2.Name then return true end end)
	end
	local selectedIndex
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	for k,v in ipairs(tmpStoryList) do
		local item=Turbine.UI.Control()
		item.ID=v.ID
		if SelectedID~=nil and v.ID==SelectedID then
			selectedIndex=k
		elseif v.ID==storySelect.currentStoryID then
			selectedIndex=k
		end
		item:SetParent(storySelect.StoryList)
		item:SetSize(storySelect.StoryList:GetWidth(),controlHeight)
		item.Active=Turbine.UI.Label()
		item.Active:SetParent(item)
		item.Active:SetSize(storySelect.ActiveHeader:GetWidth(),controlHeight)
		item.Active:SetFont(Settings.Font)
		item.Active:SetForeColor(Settings.FontColor)
		item.Active:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		if v.IsActive=="Y" then
			item.Active:SetText(Resource[language][31])
		end
		item.Active:SetMouseVisible(false)

		item.EN=Turbine.UI.Label()
		item.EN:SetParent(item)
		item.EN:SetSize(storySelect.ENHeader:GetWidth(),controlHeight)
		item.EN:SetLeft(storySelect.ENHeader:GetLeft())
		item.EN:SetFont(Settings.Font)
		item.EN:SetForeColor(Settings.FontColor)
		item.EN:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		if v.EN=="Y" then
			item.EN:SetText(Resource[language][31])
		end
		item.EN:SetMouseVisible(false)

		item.FR=Turbine.UI.Label()
		item.FR:SetParent(item)
		item.FR:SetSize(storySelect.FRHeader:GetWidth(),controlHeight)
		item.FR:SetLeft(storySelect.FRHeader:GetLeft())
		item.FR:SetFont(Settings.Font)
		item.FR:SetForeColor(Settings.FontColor)
		item.FR:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		if v.FR=="Y" then
			item.FR:SetText(Resource[language][31])
		end
		item.FR:SetMouseVisible(false)

		item.DE=Turbine.UI.Label()
		item.DE:SetParent(item)
		item.DE:SetSize(storySelect.DEHeader:GetWidth(),controlHeight)
		item.DE:SetLeft(storySelect.DEHeader:GetLeft())
		item.DE:SetFont(Settings.Font)
		item.DE:SetForeColor(Settings.FontColor)
		item.DE:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		if v.DE=="Y" then
			item.DE:SetText(Resource[language][31])
		end
		item.DE:SetMouseVisible(false)

		item.Author=Turbine.UI.Label()
		item.Author:SetParent(item)
		item.Author:SetSize(storySelect.AuthorHeader:GetWidth(),controlHeight)
		item.Author:SetLeft(storySelect.AuthorHeader:GetLeft())
		item.Author:SetFont(Settings.Font)
		item.Author:SetForeColor(Settings.FontColor)
		item.Author:SetText(v.Author)
		item.Author:SetMouseVisible(false)
		item.Name=Turbine.UI.Label()
		item.Name:SetParent(item)
		item.Name:SetSize(storySelect.NameHeader:GetWidth(),controlHeight)
		item.Name:SetLeft(storySelect.NameHeader:GetLeft())
		item.Name:SetForeColor(Settings.FontColor)
		item.Name:SetFont(Settings.Font)
		item.Name:SetText(v.Name)
		item.Name:SetMouseVisible(false)
		-- check filters
		if (storySelect.ActiveHeader:IsChecked() and v.IsActive~="Y") or (storySelect.ENHeader:IsChecked() and v.EN~="Y") or (storySelect.FRHeader:IsChecked() and v.FR~="Y") or (storySelect.DEHeader:IsChecked() and v.DE~="Y") then
			item:SetHeight(0)
		end
		-- color rows that don't support the client language
		if (language==1 and v.EN~="Y") or (language==2 and v.FR~="Y") or (language==3 and v.DE~="Y") then
			item.Supported=false
			item:SetBackColor(Turbine.UI.Color.DarkRed)
		else
			item.Supported=true
		end
		item.MouseDoubleClick=function(sender,args)
			storySelect.StoryListBox:SetSelectedItem(sender)
			storySelect.Select:Click()
		end
		item.MouseClick=function(sender,args)
			if args.Button==2 then
				storySelect.StoryListBox:SetSelectedItem(sender)
				storySelect.ShowDesc(sender.ID)
			end
		end
		storySelect.StoryListBox:AddItem(item)
	end
	if selectedIndex~=nil then
		storySelect.StoryListBox:SetSelectedIndex(selectedIndex)
	end
end
storySelect.FillStoryList(1)
storySelect.Select=Turbine.UI.Lotro.Button()
storySelect.Select:SetParent(storySelect)
storySelect.Select:SetSize(120,20)
storySelect.Select:SetPosition((storySelect:GetWidth()-storySelect.Select:GetWidth()*2)/3,storySelect:GetHeight()-35)
storySelect.Select:SetFont(Settings.Font)
storySelect.Select:SetText(Resource[language][18])
storySelect.Select.Click=function()
	if storySelect.StoryListBox:GetSelectedIndex()>0 then
		if storySelect.ReturnSelected~=nil then
			local item=storySelect.StoryListBox:GetSelectedItem()
			storySelect.SelectedAuthor=item.Author:GetText()
			storySelect.SelectedStory=item.Name:GetText()
			storySelect.SelectedID=item.ID
			storySelect.ReturnSelected()
		end
		storySelect:SetVisible(false)
		storySelect.Closed()
	end
end

storySelect.Delete=Turbine.UI.Lotro.Button()
storySelect.Delete:SetParent(storySelect)
storySelect.Delete:SetSize(120,20)
storySelect.Delete:SetPosition(storySelect.Select:GetWidth()+storySelect.Select:GetLeft()*2,storySelect:GetHeight()-35)
storySelect.Delete:SetFont(Settings.Font)
storySelect.Delete:SetText(Resource[language][11])
storySelect.Delete.Click=function()
	storySelect.Desc:SetVisible(false)
	if storySelect.StoryListBox:GetSelectedIndex()>0 then
		storySelect.MouseMask:SetMouseVisible(true)
		confirmDelete=PopUpDialog(Resource[language][33],Resource[language][34],1,Resource[language][32],Resource[language][19],nil,false,storySelect.DeleteOK)
	end
end
storySelect.DeleteOK=function(flag)
	storySelect.MouseMask:SetMouseVisible(false)
	confirmDelete=nil
	if flag==1 then
		-- clear out the associated plugindata file
		local ID=storySelect.StoryListBox:GetSelectedItem().ID
		local index=getStoryIndexFromID(ID)

		SaveSetting("Account",pluginName.."Story"..tostring(ID),"",nil,nil)
		if index~=nil then
			-- remove from StoryList
			table.remove(StoryList,index)
		end
		-- refill storySelect.StoryListBox
		storySelect.FillStoryList(storySelect.StoryListBox.SortColumn)

		currentWindow.StoryDeleted(ID)
	end
end
storySelect.Cancel=Turbine.UI.Lotro.Button()
storySelect.Cancel:SetParent(storySelect)
storySelect.Cancel:SetSize(120,20)
storySelect.Cancel:SetPosition(storySelect.Select:GetWidth()+storySelect.Select:GetLeft()*2,storySelect:GetHeight()-35)
storySelect.Cancel:SetFont(Settings.Font)
storySelect.Cancel:SetText(Resource[language][19])
storySelect.Cancel.Click=function()
	storySelect.Desc:SetVisible(false)
	storySelect:SetVisible(false)
	storySelect.Closed()
end
storySelect.MouseMask=Turbine.UI.Control()
storySelect.MouseMask:SetParent(storySelect)
storySelect.MouseMask:SetMouseVisible(false)

storySelect.Closed=function()
	storySelect.MouseMask:SetMouseVisible(false)
	currentWindow.MouseMask:SetMouseVisible(false)
end
storySelect.RefreshLayout=function()
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end
	fontMetric:SetFont(Settings.Font)

	storySelect.CurrLanguageCaption:SetSize(fontMetric:GetTextWidth(Resource[language][232]..":"),controlHeight)
	storySelect.CurrLanguageCaption:SetFont(Settings.Font)
	storySelect.CurrLanguageCaption:SetText(Resource[language][232]..":")
	storySelect.CurrLanguage:SetFont(Settings.Font)
	storySelect.CurrLanguage:SetSize(fontMetric:GetTextWidth("WW")+35,controlHeight)
	storySelect.CurrLanguage:SetLeft(storySelect.CurrLanguageCaption:GetLeft()+storySelect.CurrLanguageCaption:GetWidth()+5)

	storySelect.StoryList:SetPosition(10,storySelect.CurrLanguageCaption:GetTop()+storySelect.CurrLanguageCaption:GetHeight()+5)
	storySelect.StoryList:SetSize(storySelect:GetWidth()-20,storySelect:GetHeight()-storySelect.StoryList:GetTop()-45)

	storySelect.ActiveHeader:SetSize(fontMetric:GetTextWidth(storySelect.ActiveHeader:GetText())+35,controlHeight)
	storySelect.ActiveHeader:SetFont(Settings.Font)
	storySelect.ActiveHeader:SetText(storySelect.ActiveHeader:GetText())

	storySelect.ENHeader:SetSize(fontMetric:GetTextWidth(storySelect.ENHeader:GetText())+35,controlHeight)
	storySelect.ENHeader:SetLeft(storySelect.ActiveHeader:GetWidth()+1)
	storySelect.ENHeader:SetFont(Settings.Font)
	storySelect.ENHeader:SetText(storySelect.ENHeader:GetText())

	storySelect.FRHeader:SetSize(fontMetric:GetTextWidth(storySelect.FRHeader:GetText())+35,controlHeight)
	storySelect.FRHeader:SetLeft(storySelect.ENHeader:GetLeft()+storySelect.ENHeader:GetWidth()+1)
	storySelect.FRHeader:SetFont(Settings.Font)
	storySelect.FRHeader:SetText(storySelect.FRHeader:GetText())

	storySelect.DEHeader:SetSize(fontMetric:GetTextWidth(storySelect.DEHeader:GetText())+35,controlHeight)
	storySelect.DEHeader:SetLeft(storySelect.FRHeader:GetLeft()+storySelect.FRHeader:GetWidth()+1)
	storySelect.DEHeader:SetFont(Settings.Font)
	storySelect.DEHeader:SetText(storySelect.DEHeader:GetText())

	local tmp=fontMetric:GetTextWidth(storySelect.AuthorHeader:GetText())
	if tmp<120 then tmp=120 end
	storySelect.AuthorHeader:SetSize(tmp,controlHeight)
	storySelect.AuthorHeader:SetLeft(storySelect.DEHeader:GetLeft()+storySelect.DEHeader:GetWidth()+1)
	storySelect.AuthorHeader:SetFont(Settings.Font)
	storySelect.AuthorHeader:SetText(storySelect.AuthorHeader:GetText())

	storySelect.NameHeader:SetLeft(storySelect.AuthorHeader:GetLeft()+storySelect.AuthorHeader:GetWidth()+1)
	storySelect.NameHeader:SetSize(storySelect.StoryList:GetWidth()-storySelect.NameHeader:GetLeft(),controlHeight)
	storySelect.NameHeader:SetFont(Settings.Font)
	storySelect.NameHeader:SetText(storySelect.NameHeader:GetText())

	storySelect.StoryListBox:SetHeight(storySelect.StoryList:GetHeight()-controlHeight-2)
	storySelect.StoryListBox:SetPosition(1,controlHeight+1)
	storySelect.StoryListVScroll:SetHeight(storySelect.StoryListBox:GetHeight())
	storySelect.StoryListVScroll:SetTop(storySelect.StoryListBox:GetTop())

	storySelect.Desc:SetSize(storySelect.StoryList:GetSize())
	storySelect.Desc:SetPosition(storySelect.StoryList:GetPosition())
	storySelect.DescText:SetSize(storySelect.Desc:GetWidth()-2,storySelect.Desc:GetHeight()-2)
	storySelect.DescText:SetFont(buttonFont)

	storySelect.FillStoryList(storySelect.StoryListBox.SortColumn)

	fontMetric:SetFont(buttonFont)
	minButtonWidth=120
	tmp=fontMetric:GetTextWidth(Resource[language][18])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][11])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][19])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=storySelect:GetWidth()-70
	if minButtonWidth>tmp then minButtonWidth=tmp end

	storySelect.Select:SetFont(buttonFont)
	storySelect.Select:SetWidth(minButtonWidth)
	storySelect.Select:SetText(Resource[language][18])
	storySelect.Select:SetLeft(30)
	storySelect.Delete:SetFont(buttonFont)
	storySelect.Delete:SetText(Resource[language][11])
	storySelect.Delete:SetWidth(minButtonWidth)
	storySelect.Delete:SetLeft((storySelect:GetWidth()-storySelect.Delete:GetWidth())/2)
	storySelect.Cancel:SetFont(buttonFont)
	storySelect.Cancel:SetText(Resource[language][19])
	storySelect.Cancel:SetWidth(minButtonWidth)
	storySelect.Cancel:SetLeft(storySelect:GetWidth()-storySelect.Cancel:GetWidth()-30)
	storySelect.MouseMask:SetSize(storySelect:GetSize())
end
storySelect.RefreshLayout()
storySelect.RefreshColor=function()
	storySelect.StoryList:SetBackColor(Settings.TrimColor)
	storySelect.StoryListBox:SetBackColor(Settings.BackColor)
	for i=1,storySelect.StoryListBox:GetItemCount() do
		local tmpItem=storySelect.StoryListBox:GetItem(i)
		tmpItem.Active:SetForeColor(Settings.FontColor)
		tmpItem.EN:SetForeColor(Settings.FontColor)
		tmpItem.FR:SetForeColor(Settings.FontColor)
		tmpItem.DE:SetForeColor(Settings.FontColor)
		tmpItem.Author:SetForeColor(Settings.FontColor)
		tmpItem.Name:SetForeColor(Settings.FontColor)
	end
	storySelect.CurrLanguageCaption:SetForeColor(Settings.LabelColor)
	storySelect.CurrLanguage:SetBorderColor(Settings.TrimColor)
	storySelect.CurrLanguage:SetBackColor(Settings.BackColor)
	storySelect.CurrLanguage.CurrentValue:SetBackColor(Settings.BackColor)
	storySelect.CurrLanguage:SetTextColor(Settings.FontColor)
end
storySelect.RefreshColor()
storySelect:SetZOrder(1)
